/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "defs.h"
#include "cpu.h"
#include "mmx.h"

void (*try_crack_pwl)(Params *p, Pwl *pwl);

void chose_crack_core()
{
  Cpu_desc cpu;
  char *vendorstr;
  
  try_crack_pwl = &try_crack_pwl_mmx; /* only existing core right now */
  idcpu(&cpu);
  switch(cpu.vendid) {
  case INTEL:
    vendorstr = "n Intel";
    break;
  case AMD:
    vendorstr = "n Amd";
    break;
  case IDT:
    vendorstr = "n Idt";
    break;
  case NG:
    vendorstr = " NexGen";
    break;
  case CYRIX:
    vendorstr = " Cyrix";
    break;
  case UMC:
    vendorstr = "n Umc";
    break;
  case RISE:
    vendorstr = " Rise";
    break;
  case TRANSM:
    vendorstr = " Transmeta";
    break;
  default:
    vendorstr = "n unknown";
    break;
  }

  printf("Detected a%s processor, family %d\n  l1 code cache size = %d Kb\n  l1 data cache size = %d Kb\n  l2 cache size = %d Kb\n  Present features :%s\n\n", vendorstr, (int)cpu.family, (int)cpu.l1c, (int)cpu.l1d, (int)cpu.l2, cpu.uisfeat);

}

