/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Make xor table (MMX) */

.text

#define dualstore(a) \
	movq	%mm0, a(%edi);	\
	paddb	%mm2, %mm0;	\
	movq	%mm1, 8+a(%edi);\
	paddb	%mm2, %mm1

#define store32x(b) \
	dualstore(b+ 0*16); dualstore(b+ 1*16); dualstore(b+ 2*16); dualstore(b+ 3*16);  \
	dualstore(b+ 4*16); dualstore(b+ 5*16); dualstore(b+ 6*16); dualstore(b+ 7*16);  \
	dualstore(b+ 8*16); dualstore(b+ 9*16); dualstore(b+10*16); dualstore(b+11*16);  \
	dualstore(b+12*16); dualstore(b+13*16); dualstore(b+14*16); dualstore(b+15*16);

	.align 32
	.globl mkxor
mkxor:
	pushl	%edi
	pushl   %esi
	
	movl	16(%esp), %edi
	movl	12(%esp), %esi

	pushl	%edx
	pushl	%ecx
	pushl	%ebx
	
	pcmpeqb	%mm2, %mm2
	pxor	%mm1, %mm1
	pxor	%mm0, %mm0	/* 0..0 */
	psubb	%mm2, %mm1	/* 1..1 */
	movq	%mm1, %mm2
	paddb	%mm1, %mm2	/* 2..2 */

	store32x(0)
	store32x(32*8)
	store32x(64*8)
	store32x(96*8)
	store32x(128*8)
	store32x(160*8)
	store32x(192*8)
	store32x(224*8)
		
	xorl	%eax, %eax	/* i */
	xorl	%ecx, %ecx	/* i & 0xF */
	pxor	%mm7, %mm7	/* t[0..7] */

	.p2align 4
swap8x:
	paddb	(%esi, %ecx, 8), %mm7	/* t += src[i&0xf] */
	movq	(%edi, %eax, 8), %mm0	/* dest[i][0..7] */
	movl	$0xFF, %ebx
	paddb	%mm0, %mm7	/* t += dest[i] */
	movq	%mm7, %mm4
	movd	%mm7, %edx
	movd	%ebx, %mm5	/* mask = [00 00 .. 00 FF] */
	movzbl	%dl, %ebx	/* t[0] */
	pxor	%mm6, %mm6	/* futur dest[i][0..7] */
	psrlq	$32, %mm4

	movq	(%edi, %ebx, 8), %mm1 /* dest[t[0]][0..7]  */
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2	/* dest[i][0] */
	pandn	%mm1, %mm3	/* dest[t[0]][~0] */
	pand	%mm5, %mm1	/* dest[t[0]][0] */
	por	%mm2, %mm3	/* dest[i][0] | dest[t[0]][1..7] */
	por	%mm1, %mm6	/* futur dest[i][0] */
	movq	%mm3, (%edi, %ebx, 8)
	movzbl	%dh, %ebx	/* t[1] */
	psllq	$8, %mm5	/* mask = [00 00 .. FF 00] */

	movq	(%edi, %ebx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	shrl	$16, %edx
	por	%mm1, %mm6
	movq	%mm3, (%edi, %ebx, 8)
	movzbl	%dl, %ebx
	psllq	$8, %mm5

	movq	(%edi, %ebx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	por	%mm1, %mm6
	movq	%mm3, (%edi, %ebx, 8)
	movzbl	%dh, %ebx
	psllq	$8, %mm5

	movq	(%edi, %ebx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	movd	%mm4, %edx	/* */
	por	%mm1, %mm6
	movq	%mm3, (%edi, %ebx, 8)
	movzbl	%dl, %ebx
	psllq	$8, %mm5

	movq	(%edi, %ebx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	por	%mm1, %mm6
	movq	%mm3, (%edi, %ebx, 8)
	movzbl	%dh, %ebx
	psllq	$8, %mm5

	movq	(%edi, %ebx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	shrl	$16, %edx
	por	%mm1, %mm6
	movq	%mm3, (%edi, %ebx, 8)
	movzbl	%dl, %ebx
	psllq	$8, %mm5

	movq	(%edi, %ebx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	por	%mm1, %mm6
	movq	%mm3, (%edi, %ebx, 8)
	movzbl	%dh, %ebx
	psllq	$8, %mm5

	movq	(%edi, %ebx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	incl	%eax
	por	%mm1, %mm6
	movq	%mm3, (%edi, %ebx, 8)
	incl	%ecx

	movq	%mm6, -8(%edi, %eax, 8)
	andl	$0xF, %ecx

	cmpl	$256, %eax
	jne	swap8x

	popl	%ebx
	popl	%ecx
	popl	%edx
	popl	%esi
	popl	%edi
	ret

	.align 32
	.globl rcxor
rcxor:
	pushl	%ebx
	pushl	%ecx
	pushl	%edx
	pushl	%esi
	pushl	%edi
	
	movl	24(%esp), %ebx
	movl	28(%esp), %esi
	movl	32(%esp), %edi

/*	movq	8(%ebx), %mm7*/
	movl	$0xFF, %ecx
/*	movl	$1, %eax*/
	movd	%ecx, %mm5
/*	movq	%mm7, %mm0*/
	movq	(%ebx, %eax, 8), %mm0
	
	.p2align 4
xor8x:	
	pxor	%mm6, %mm6
	movq	%mm7, %mm4
	movd	%mm7, %edx
	psrlq	$32, %mm4
	movzbl	%dl, %ecx
		
	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	movzbl	%dh, %ecx
	psllq	$8, %mm5

	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	shrl	$16, %edx
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	movzbl	%dl, %ecx
	psllq	$8, %mm5

	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	movzbl	%dh, %ecx
	psllq	$8, %mm5
	
	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	movd	%mm4, %edx	/* */
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	movzbl	%dl, %ecx
	psllq	$8, %mm5
	
	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	movzbl	%dh, %ecx
	psllq	$8, %mm5

	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	shrl	$16, %edx
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	movzbl	%dl, %ecx
	psllq	$8, %mm5

	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	movzbl	%dh, %ecx
	psllq	$8, %mm5

	movq	(%ebx, %ecx, 8), %mm1
	movq	%mm5, %mm2
	movq	%mm5, %mm3
	pand	%mm0, %mm2
	pandn	%mm1, %mm3
	pand	%mm5, %mm1
	por	%mm2, %mm3
	movq	%mm0, %mm4
	por	%mm1, %mm6
	movq	%mm3, (%ebx, %ecx, 8)
	paddb	%mm6, %mm4
	psrlq	$56, %mm5

	movq	%mm6, (%ebx, %eax, 8)
	movd	%mm4, %edx
	movzbl	%dl, %ecx

	movq	(%ebx, %ecx, 8), %mm1
	movzbl	%dh, %ecx
	psrlq	$32, %mm4
	movq	-8(%esi, %eax, 8), %mm3

	movq	(%ebx, %ecx, 8), %mm2
	shrl	$16, %edx
	pand	%mm5, %mm1
	movzbl	%dl, %ecx
	psllq	$8, %mm5
	pxor	%mm1, %mm3

	movq	(%ebx, %ecx, 8), %mm1
	pand	%mm5, %mm2
	movzbl	%dh, %ecx
	psllq	$8, %mm5
	pxor	%mm2, %mm3

	movq	(%ebx, %ecx, 8), %mm2
	movd	%mm4, %edx
	pand	%mm5, %mm1
	movzbl	%dl, %ecx
	psllq	$8, %mm5
	pxor	%mm1, %mm3

	movq	(%ebx, %ecx, 8), %mm1
	pand	%mm5, %mm2
	movzbl	%dh, %ecx
	psllq	$8, %mm5
	pxor	%mm2, %mm3

	movq	(%ebx, %ecx, 8), %mm2
	shrl	$16, %edx
	pand	%mm5, %mm1
	movzbl	%dl, %ecx
	psllq	$8, %mm5
	pxor	%mm1, %mm3

	movq	(%ebx, %ecx, 8), %mm1
	pand	%mm5, %mm2
	movzbl	%dh, %ecx
	psllq	$8, %mm5
	pxor	%mm2, %mm3

	movq	(%ebx, %ecx, 8), %mm2
	incl	%eax
	pand	%mm5, %mm1
	psllq	$8, %mm5
	pand	%mm5, %mm2
	movq	(%ebx, %eax, 8), %mm0
	pxor	%mm1, %mm3
	pxor	%mm2, %mm3

	psrlq	$56, %mm5
	cmp	36(%esp), %eax
	movq	%mm3, -16(%edi, %eax, 8)
	paddb	%mm0, %mm7
	jbe	xor8x


	popl	%edi
	popl	%esi
	popl	%edx
	popl	%ecx
	popl	%ebx
	ret
